package core

import (
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/pkg/repository/result"
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/logic/core"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/svc"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/types"
)

func CommitTaskHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.CommitTaskReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := core.NewCommitTaskLogic(r.Context(), svcCtx)
		err := l.CommitTask(&req)
		result.HttpResult(r, w, nil, err)
	}
}
