package participantservicelogic

import (
	"context"

	"gitlink.org.cn/jcce-pcm/pcm-coordinator/rpc/internal/svc"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/rpc/pcmCore"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteListLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewDeleteListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteListLogic {
	return &DeleteListLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// DeleteList 删除任务列表
func (l *DeleteListLogic) DeleteList(in *pcmCore.ApplyListReq) (*pcmCore.ApplyListResp, error) {
	result := pcmCore.ApplyListResp{
		InfoList: make([]*pcmCore.ApplyInfo, 0),
	}
	l.svcCtx.DbEngin.Raw("SELECT sppi.`name` as ParticipantName,c.yaml_string as YamlString FROM cloud c,sc_participant_phy_info sppi where c.`status` = 'WaitDelete' and sppi.id = c.participant_id").Scan(&result.InfoList)
	if len(result.InfoList) != 0 {
		l.svcCtx.DbEngin.Exec("update cloud set status = ? where status = ?", "Deleted", "WaitDelete")
	}
	return &result, nil
}
